package cn.com.qmth.examcloud.support.examing;

import cn.com.qmth.examcloud.api.commons.enums.ExamType;
import cn.com.qmth.examcloud.api.commons.exchange.JsonSerializable;
import cn.com.qmth.examcloud.support.enums.ExamRecordStatus;
import cn.com.qmth.examcloud.support.enums.HandInExamType;
import cn.com.qmth.examcloud.support.enums.IsSuccess;
import cn.com.qmth.examcloud.support.enums.SyncStatus;
import lombok.Data;

import java.util.Date;

@Data
public class ExamRecordData implements JsonSerializable {

    private static final long serialVersionUID = 3881189287358373638L;

    /**
     * 主键
     */
    private Long id;

    /**
     * 考试ID
     */
    private Long examId;

    /**
     * 考试类型
     */
    private ExamType examType;

    /**
     * 考生ID
     */
    private Long examStudentId;

    /**
     * 学生ID
     */
    private Long studentId;

    /**
     * 课程ID
     */
    private Long courseId;

    /**
     * 学习中心ID
     */
    private Long orgId;

    /**
     * 顶级机构ID
     */
    private Long rootOrgId;

    /**
     * 基础试卷ID
     */
    private String basePaperId;

    /**
     * 试卷类型
     */
    private String paperType;

    /**
     * 考试开始时间(即开始作答时间)
     */
    private Date startTime;

    /**
     * 考试结束时间
     */
    private Date endTime;

    /**
     * 考试时长(毫秒)
     */
    private Long usedExamTime;

    /**
     * 是否断点续考
     */
    private Boolean isContinued;

    /**
     * 断点续考次数
     */
    private Integer continuedCount;

    /**
     * 是否达到最大断点限制
     */
    private Boolean isExceed;

    /**
     * 抓拍比对成功次数
     */
    private Integer faceSuccessCount;

    /**
     * 抓拍比对失败次数
     */
    private Integer faceFailedCount;

    /**
     * 抓拍存在陌生人的次数
     */
    private Integer faceStrangerCount;

    /**
     * 抓拍比对总次数
     */
    private Integer faceTotalCount;

    // 考试记录状态
    private ExamRecordStatus examRecordStatus;

    /**
     * 交卷类型
     */
    private HandInExamType handInExamType;

    /**
     * 活体检测结果
     */
    private IsSuccess faceVerifyResult;

    /**
     * 考试被清理时间
     */
    private Date cleanTime;

    /**
     * 是否异常数据
     */
    private Boolean isWarn;
    /**
     * 是否被审核过
     */
    private Boolean isAudit;
    /**
     * 是否违纪
     */
    private Boolean isIllegality;

    /**
     * 总分
     */
    private Double totalScore;

    /**
     * 客观题得分总分
     */
    private Double objectiveScore;

    /**
     * 客观题答对的比率
     * (客观题答对的题数/客观题总题数)*100  取2位小数
     */
    private Double objectiveAccuracy;

    /**
     * 主观题得分总分
     */
    private Double subjectiveScore;

    /**
     * 答题正确率
     */
    private Double succPercent;

    /**
     * 抓拍比对通过率
     */
    private Double faceSuccessPercent;

    /**
     * 百度人脸活体检测通过率
     */
    private Double baiduFaceLivenessSuccessPercent;

    /**
     * 数据同步状态
     */
    private SyncStatus syncStatus;

    /**
     * 试卷题目数量（校验提交答案的order）
     */
    private Integer questionCount;

    /**
     * 是否是全客观题卷  1:是   0:否
     */
    private Boolean isAllObjectivePaper;

    /**
     * 场次id
     */
    private Long examStageId;

    /**
     * 场次号
     */
    private Integer examStageOrder;

    /**
     * 学生最后活动时间
     */
    private Date lastActiveTime;

    /**
     * 断点续考时间
     */
    private Date continuedTime;

    /**
     * 进入考试时间
     */
    private Date enterExamTime;

    /**
     * 切屏次数
     */
    private Integer switchScreenCount;

}
